<template>
	<div class="mod-config">
		<el-form :inline="true" :model="dataForm">
			<el-form-item :label="$t('eq.groupname')">
				<strong>{{ $route.params.groupName || '--' }}</strong></el-form-item
			>

			<el-form-item :label="$t('eq.groupcode')">
				<strong>{{ $route.params.groupCode || '--' }}</strong>
			</el-form-item>
			<!-- <el-form-item>
				<el-input v-model="dataForm.key" :placeholder="$t('parameter')" clearable></el-input>
			</el-form-item> -->
			<br />
			<el-form-item>
				<!-- 报警编码/内容检索 -->
				<el-input :placeholder="$t('alarm.code') + '/' + $t('alarm.content')" v-model="dataForm.key" clearable />
			</el-form-item>
			<el-form-item>
				<el-button @click="currentChangeHandle(1)">{{ $t('query') }}</el-button>
				<el-button v-if="$route.params.id && $hasPermission('monitoring:equipmentgroupalarm:save')" type="primary" @click="addOrUpdateHandle()">{{ $t('add') }}</el-button>
				<!-- <el-button v-if="$hasPermission('monitoring:equipmentgroupalarm:delete')" type="danger" @click="deleteHandle()" :disabled="dataListSelections.length <= 0">
					批量删除
				</el-button> -->
			</el-form-item>
		</el-form>

		<base-table
			:page="pageIndex"
			:size="pageSize"
			:data="dataList"
			:table-head-configs="tableConfigs"
			:max-height="calcMaxHeight(8)"
			@operate-event="handleOperations"
			@refreshDataList="getDataList"
		/>
		<el-pagination
			@size-change="sizeChangeHandle"
			@current-change="currentChangeHandle"
			:current-page="pageIndex"
			:page-sizes="[10, 20, 50, 100]"
			:page-size="pageSize"
			:total="totalPage"
			layout="total, sizes, prev, pager, next, jumper"
		></el-pagination>
		<!-- 弹窗, 新增 / 修改 -->
		<add-or-update v-if="addOrUpdateVisible" ref="addOrUpdate" :configs="addOrUpdateConfigs" @refreshDataList="getDataList" @destory-dialog="addOrUpdateVisible = false" />
	</div>
</template>

<script>
import { calcMaxHeight } from '@/utils'
import { timeFilter, dictFilter } from '@/utils/filters'
// import AddOrUpdate from './equipmentGroupAlarm-add-or-update'
import AddOrUpdate from '@/components/base-dialog/addOrUpdate'
import i18n from '@/i18n'
import BaseTable from '@/components/base-table'
import dictListMixin from '@/mixins/dictlist-module'
import TableOperateComponent from '@/components/base-table/components/operationComponent'
// import TableTextComponent from '@/components/base-table/components/detailComponent'

// const alarmTypeDictId = '1557925215454814210'
// const alarmLevelDictId = '1557925289517834242'
const dictEntries = {
	alarmType: { value: '1557925215454814210', field: 'typeDictValue' }, // field 和下面 addOrUpdateConfigs 里对应
	alarmLevel: { value: '1557925289517834242', field: 'gradeDictValue' }
}

const tableConfigs = [
	{
		type: 'index',
		name: i18n.t('index')
	},
	{ prop: 'createTime', name: i18n.t('createTime'), filter: timeFilter },
	{ prop: 'code', name: i18n.t('alarm.code') },
	{ prop: 'typeDictValue', name: i18n.t('alarm.type'), filter: dictFilter(dictEntries.alarmType.value) },
	{ prop: 'gradeDictValue', name: i18n.t('alarm.level'), filter: dictFilter(dictEntries.alarmLevel.value) },
	{ prop: 'alarmContent', name: i18n.t('alarm.content') },
	{ prop: 'externalCode', name: i18n.t('alarm.externalCode') },
	{ prop: 'operations', name: i18n.t('handle'), fixed: 'right', width: 180, subcomponent: TableOperateComponent, options: ['edit', 'delete'] }
]

const addOrUpdateConfigs = {
	type: 'dialog',
	infoUrl: '/monitoring/equipmentGroupAlarm',
	fields: [
		{ name: 'code', label: i18n.t('alarm.code'), api: '/monitoring/equipmentGroupAlarm/getCode', required: true },
		{ name: 'typeDictValue', label: i18n.t('alarm.type'), type: 'select', options: [] },
		{ name: 'gradeDictValue', label: i18n.t('alarm.level'), type: 'select', options: [] },
		{ name: 'alarmContent', label: i18n.t('alarm.content'), required: true },
		{ name: 'externalCode', label: i18n.t('alarm.externalCode') }
	],
	operations: [
		{ name: 'cancel', showAlways: true },
		{ name: 'save', url: '/monitoring/equipmentGroupAlarm', extraFields: { equipmentGroupId: null }, permission: 'monitoring:equipmentgroupalarm:save', showOnEdit: false },
		{ name: 'update', url: '/monitoring/equipmentGroupAlarm', extraFields: { equipmentGroupId: null }, permission: 'monitoring:equipmentgroupalarm:update', showOnEdit: true }
	]
}

export default {
	mixins: [dictListMixin],
	data() {
		return {
			addOrUpdateConfigs,
			calcMaxHeight,
			tableConfigs,
			dataForm: {
				key: ''
			},
			dataList: [],
			pageIndex: 1,
			pageSize: 10,
			totalPage: 0,
			dataListLoading: false,
			dataListSelections: [],
			addOrUpdateVisible: false
		}
	},
	components: {
		AddOrUpdate,
		BaseTable
	},
	activated() {
		this.getDictData()
		this.getDataList()
	},
	methods: {
		// 获取字典数据
		getDictData() {
			this.initDictList(Object.entries(dictEntries).map(([_, item]) => item.value))
			this.addOrUpdateConfigs.fields.forEach(item => {
				if (item.options && Array.isArray(item.options)) {
					let id
					Object.entries(dictEntries).forEach(([_, d]) => {
						if (d.field === item.name) {
							id = d.value
						}
					})
					item.options = this.dictList[id]
				}
			})
		},
		// 获取数据列表
		getDataList() {
			this.dataListLoading = true

			const queryParams = {
				page: this.pageIndex,
				limit: this.pageSize,
				groupId: this.$route.params.id
			}

			if (this.dataForm.key && this.dataForm.key.trim() !== '') queryParams.key = this.dataForm.key

			this.$http({
				url: this.$http.adornUrl('/monitoring/equipmentGroupAlarm/page'),
				method: 'get',
				params: this.$http.adornParams(queryParams)
			}).then(({ data }) => {
				if (data && data.code === 0) {
					this.dataList = data.data.list
					this.totalPage = data.data.total
				} else {
					this.dataList = []
					this.totalPage = 0
				}
				this.dataListLoading = false
			})
		},
		// 每页数
		sizeChangeHandle(val) {
			this.pageSize = val
			this.pageIndex = 1
			this.getDataList()
		},
		// 当前页
		currentChangeHandle(val) {
			this.pageIndex = val
			this.getDataList()
		},
		// 多选
		selectionChangeHandle(val) {
			this.dataListSelections = val
		},
		handleOperations({ type, data: id }) {
			switch (type) {
				case 'edit':
					return this.addOrUpdateHandle(id)
				case 'delete':
					return this.deleteHandle(id)
			}
		},
		// 新增 / 修改
		addOrUpdateHandle(id) {
			this.addOrUpdateConfigs.operations.forEach(item => {
				if (item.extraFields) {
					item.extraFields.equipmentGroupId = this.$route.params.id || null
				}
			})
			this.addOrUpdateVisible = true
			this.$nextTick(() => {
				this.$refs.addOrUpdate.init(id)
			})
		},
		// 删除
		deleteHandle(id) {
			var ids = id
				? [id]
				: this.dataListSelections.map(item => {
						return item.id
				  })
			this.$confirm(`${i18n.t('prompt.info', { handle: id ? i18n.t('delete').toLowerCase() : i18n.t('deleteBatch').toLowerCase() })}`, i18n.t('prompt.title'), {
				confirmButtonText: i18n.t('confirm'),
				cancelButtonText: i18n.t('cancel'),
				type: 'warning'
			}).then(() => {
				this.$http({
					url: this.$http.adornUrl('/monitoring/equipmentGroupAlarm'),
					method: 'delete',
					data: this.$http.adornData(ids, false, 'raw')
				}).then(({ data }) => {
					if (data && data.code === 0) {
						this.$message({
							message: i18n.t('prompt.success'),
							type: 'success',
							duration: 1500,
							onClose: () => {
								this.getDataList()
							}
						})
					} else {
						this.$message.error(data.msg)
					}
				})
			})
		}
	}
}
</script>
